
#include "RicartAgrwl.h"

int left=0;

/*THIS FUNCTION IS USED TO SET THE HOSTS TABLE AND THE self VARIABLE AT
 * EACH NODE */
void set_hosts()
{
	int j , i ;
        char *ch, name[40];
	FILE * fp ;
	fp= fopen("./hosts.txt" , "r");
	if(! fp)
	{
		printf("File opening Error\n");
		exit (1);
	}

	for ( j = 0 ; j<10 ; j++ )
	{
		gethostname(name , 10 );
		printf("self %s\n",name);
		if((i = fscanf(fp , "%s" , &hosts[j][0] ) ) == EOF ) break ;
		
		if ( !strcmp ( name , hosts[j] ))
		{
	        	self = j ;
			printf("%d __ %s",j,hosts[j]);
		}
      	}
	printf("%s",hosts[1] );
}

void init()
{
	int j;

	set_hosts();
	
	n = NUM_OF_MEMBERS ;	

	osn = 0 ;

	hsn = 0 ;

	for(j = 0; j <= n-1 ; j++)
		repdeferred[j] = FALSE ;

	/* To take care of the nodes that have terminated */
	for(j=0;j<10;j++)
	{
		if(j<n)
			left_grp[j] = 0;
		else
			left_grp[j] = -1;
	}

}

void transmit(int msg_type,int ts, int reciever)
{
	struct sockaddr_in addr;
	struct hostent *h;
	struct req_rep msg;
	int sockfd,j;
	
	sockfd = socket(AF_INET,SOCK_DGRAM, 0);
	bzero(&addr, sizeof(addr));
	addr.sin_family = AF_INET ;
	addr.sin_port = htons(PORT);	

	/*Packing the request to be sent to the other hosts*/
	msg.mtype = msg_type;
	msg.t_stamp = ts;
	msg.sender = self;


	/* Finding the reciever and sending the REQUEST as a UDP packet*/
	h = gethostbyname(hosts[reciever]);
	inet_pton(AF_INET, inet_ntoa( *((int *)h->h_addr)),&addr.sin_addr);

	printf("%s",inet_ntoa( *((int *)h->h_addr )) );
	//bcopy ( h -> h_addr , (caddr_t)(&(addr.sin_addr)) , h -> h_length );
	printf("sending request to %s\n" , hosts[reciever]);
        j = sendto ( sockfd , &msg , sizeof(req_rep) , 0 , (struct sockaddr *)&addr , sizeof ( addr ) );
	
	printf("After %d bytes & sending request to %s \n" ,j, hosts[reciever]);
}
void enter_cs()
{
	int j;
	csrequested = TRUE ;
	osn = hsn + 1;
	numexpected = n - 1 ;
	printf("CS Requested\n");
	
	for(j=0;j<n;j++)
		if(left_grp[j] == 1)
			numexpected--;
	for(j=0;j<n;j++)
	{
		if(j==self || left_grp[j] == 1)
			continue;
		/*establish a UDP socket and send request to it*/
		transmit(REQ, osn ,j);//transmit function knows self , tell it 
	}			      //whom to send	 
	while(numexpected!=0)
	{
	}
	printf("Entering CS \n");
}

void release_cs()
{
	int j;
	csrequested =FALSE ;
	for(j = 0;j<n; j++)
	{
		if(repdeferred[j] == TRUE && left_grp[j]!= 1)
		{
			repdeferred[j] = FALSE;
			transmit(REP,0,j);
		}
	}

}

void receive_mcast()
{ 
	struct in_addr mcastAddr;
	struct sockaddr_in addr; 
	struct ip_mreq mreq;  
	char message[40];
	struct hostent *h;
	char multicast[] = "224.6.6.6" ;
	int sd,rc, j;
	

	h = gethostbyname(multicast);
	
	memcpy(&mcastAddr, h->h_addr_list[0],h->h_length);  
      	
	if(!IN_MULTICAST(ntohl(mcastAddr.s_addr)))
        {
                printf(" given address '%s' is not multicast\n",
                inet_ntoa(mcastAddr));
                exit(1);
        }       
	
	sd = socket(AF_INET, SOCK_DGRAM , 0);
	if(sd < 0 )
	{
		printf("Cannot open Socket \n ");
		exit (1);
	}
	
	bzero(&addr ,sizeof(addr));
	addr.sin_family = AF_INET ;
	addr.sin_port = htons(MCAST_PORT);
	
	rc = bind ( sd , (struct sockaddr * )&addr , sizeof(addr) );
	if(rc < 0)
	{
		printf("Unable to bind to port %d\n",PORT);
		exit (1);
	}
  	/* join multicast group */
        mreq.imr_multiaddr.s_addr=mcastAddr.s_addr;
        mreq.imr_interface.s_addr=htonl(INADDR_ANY);  

       	rc = setsockopt(sd,IPPROTO_IP,IP_ADD_MEMBERSHIP,(void *) &mreq, sizeof(mreq));
        if(rc<0)
        {
                printf(" : cannot join multicast group '%s'",
                inet_ntoa(mcastAddr));
                exit(1);
        }             
	
        while(1)
	{
                recvfrom ( sd , (void *)message , 20 , 0 , NULL , &j ) ;
                printf ( "Received message : %s\n " , message );
                printf ( "Type the message to be broadcast.OR Press $ to quit \n");
        }         
}

void process_msg()
{
	 int sd,rc,j;
	 struct sockaddr_in servaddr;
	 struct req_rep rcvd_msg;
	
	 printf("In process message : \n");
	 sd = socket(AF_INET, SOCK_DGRAM , 0);
	 if(sd < 0 )
	 {
		 printf("Cannot open Socket \n ");
		 exit (1);
	 }

	 /*bind local server port */

	 servaddr.sin_family = AF_INET ;
	 servaddr.sin_port = htons(PORT) ;
	 servaddr.sin_addr.s_addr =htonl(INADDR_ANY);
	 rc = bind (sd,(struct sockaddr_in * )&servaddr, sizeof(servaddr));
	 if(rc < 0)
	 {
		 printf("Unable to bind to port %d\n",PORT);
		 exit (1);
	 }
         while(1)
         {
         	j = 0 ;
                rc = recvfrom ( sd , (void *)&rcvd_msg , sizeof(struct req_rep) , 0 , NULL , &j ) ;
		printf("Recieved message from the other side %d bytes \n",rc);
 
                if ( rcvd_msg.mtype == REQ )
                {
                        hsn = (hsn > rcvd_msg.t_stamp) ? hsn : rcvd_msg.t_stamp  ;
 
                        if ( csrequested && ( ( rcvd_msg.t_stamp > osn ) ||
			                     ((rcvd_msg.t_stamp == osn ) && 
					      (self < rcvd_msg.sender)) ) )
                        {
                                repdeferred[rcvd_msg.sender] = TRUE ;
                        }
                        else
                        {
                                repdeferred[rcvd_msg.sender] = FALSE ;
                                transmit ( REP , 0 , rcvd_msg.sender) ;
                        }
                }
                else if ( rcvd_msg.mtype == REP )
                {
			printf("Recieved reply\n");
                        numexpected -- ;
                }
		else if( rcvd_msg.mtype == TERMINATED)
		{
			left++;
			left_grp[rcvd_msg.sender]=1;
			for(j=0;j<n;j++)
				if(left_grp[j] == 1)
					printf("%s has left the group\n",hosts[j]);
			printf("left == %d\n",left);
			if(NUM_OF_MEMBERS - left == 1)
			{
				printf("I am the only member left:Terminating\n");
				exit(1);
			}
        
		}                            


	 }
}

void terminating()
{
	int j;	
	for(j=0;j<n;j++)
	{
		if(j==self || left_grp[j] == 1)
			continue;
		/*establish a UDP socket and send request to it*/
		transmit(TERMINATED, 0 ,j);//transmit function knows self , tell it 
	}			      //whom to send	 


}
	
main()
{
	int sockfd,rc;
	struct sockaddr_in m_addr ; 
       	char c ,choice, message[20]; 
	init();
	
	pthread_create(&thread1,NULL, (void *)(process_msg), NULL );
	pthread_create(&thread2,NULL , (void *)(receive_mcast),NULL );

	printf("\nEnter the message to be sent out to group members..... \n");

	sockfd = socket(AF_INET, SOCK_DGRAM ,0 );
	bzero(&m_addr ,sizeof(m_addr));
	m_addr.sin_family = AF_INET ;
	m_addr.sin_port = htons(MCAST_PORT);
	inet_pton(AF_INET, "224.6.6.6" , &m_addr.sin_addr);

	while(1)
	{
			
		scanf("%s", message);
		
		if(strlen(message) == 1 && !strncmp(message, "$" ,1))
		{
			printf("Terminating ...\n");
			left_grp[self] = 0;
			left++;
			terminating();		
			exit(1);
		}
		
		printf("Entering CS\n");
                enter_cs() ;
                
		printf("Entered CS\n");
                
		rc = sendto( sockfd , &message[0] , 10 , 0 ,
                                (struct sockaddr *)&m_addr,sizeof ( m_addr ) ) ;
                printf("sent message %d\n",rc);
                
		release_cs();       
	}

}




